// ==UserScript==
// @name		WebarooSearchRadar
// @namespace   http://searchradar.webaroo.com/
// @author		Webaroo.
// @include		http://*.search.yahoo.*/search*
// @include     http://*.google.*/search*
// @description	When you search using Google or Yahoo, this plug-in displays a list of relevant search queries on the right to help you refine your search query. The suggested queries are displayed in a manner so as to not interfere with list of search results. Moving your mouse pointer over a related search query displays additional information and can help you decide if you want to refine your query.
// @version		2.0.5
// ==/UserScript==
(function() {
    try
    {
    var currentVersion = "2.0.5";
    var numResultsToDisplay = IS_getNumRes();
    var latestVersion;
    var prevVal = -1;
    var inPopup = 0;
    var toRemovePop = 0;
    var webarooResults;
	var webarooExcerpts;
	var webarooUrls;
	var base = 'http://'+location.host+'/search';
	var globalUrl = "http://searchradar.webaroo.com/";
    var sep = ' ' + unescape('%u3000');
    var webarooMessage;

    //variables depending on the search engine
    var isGoogle; //variable
    var queryBase; //variable
    var borderColor; //variable
    var popColor; //variable
    var initInner; //variable
    var ender; //variable
    var rsearches; //variable
    //var header; //variable
    var throbberHtml;//variable
    var tagCloudHtml; //variable
    var pad; //variable
    var noResHtml; //variable


    //emchar (fixed)
    var emchar = new Array();
    emchar['digit'] = unescape('%uFF10-%uFF19');
    emchar['cChar'] = unescape('%uFF21-%uFF3A');
    emchar['lChar'] = unescape('%uFF41-%uFF5A');
    emchar['hKana']  = unescape('%u3042-%u3093');
    emchar['kKana']  = unescape('%u30A1-%u30F4%u30FC');
    emchar['kanji'] = unescape('%u4E00-%u9FA0');
    emchar['other'] = unescape('%u2015%uFF1D%uFF0B%uFF01%uFF1F');
    
    //need update function (fixed)
    function needUpdate(v1) 
    {
        var v2 = currentVersion.split(".");
        v1 = v1.split(".");

        if (v1[0] == "") v1[0] = "0";
        if (v2[0] == "") v2[0] = "0";

        while (v1.length < v2.length) 
        {
            v1.push("0");
        }

        while (v2.length < v1.length) 
        {
            v2.push("0");
        }

        var diff;
        for (var i = 0; i < v1.length; i++) 
        {
            diff = parseInt(v1[i]) - parseInt(v2[i]);
            if (diff != 0) 
            {
                return diff > 0;
            } else 
            {
                continue;
            }
        }
        return false;
    }

    //Thanks Google Tag Cloud Maker grease monkey script (fixed)
    var getSearchQuery = function()
    {
	    var qs = document.getElementsByTagName('input');
	    for(var i = 0; i < qs.length; i++)
	    {
	        var regex = "^" + queryBase + "$";
	        if(qs[i].name.match(regex))
	        {
		        var str = qs[i].value;
//		        str = str.replace(/\//g, '\\/');
//		        str = str.replace(/([\+\-\.\?\!\=\^\$])/g, function($0){ return '\\'+$0;});
		        str = str.replace(/\"/g, '');
		        eval('str = str.replace(/(['+emchar['cChar']+emchar['lChar']+emchar['digit']+'])/g, function($0){ return String.fromCharCode($0.charCodeAt(0) - 65248);})');
		        return eval('str.split(/['+sep+']+/)');
	        }
	    }
    }

    //Thanks the ultimate getElementsByClassName (fixed)
    var getElementsByClassName = function(oElm, strTagName, strClassName)
    {
	    var arrElements = (strTagName == "*" && oElm.all)? oElm.all : oElm.getElementsByTagName(strTagName);
	    var arrReturnElements = new Array();
	    strClassName = strClassName.replace(/-/g, "\-");
	    var oRegExp = new RegExp("(^|\s)" + strClassName + "(\s|$)");
	    var oElement;
	    for(var i=0; i<arrElements.length; i++)
	    {
		    oElement = arrElements[i];
		    if(oRegExp.test(oElement.className))
		    {
			    arrReturnElements.push(oElement);
		    }
	    }
	    return (arrReturnElements)
    }

    // fixed with use of proper variables
	var showResults = function(numResultsFound)
	{
		var cld = document.getElementById("cTags");
		var inner = isGoogle ? "" : "<br>";
		if(numResultsFound == 0)
		{
			inner = noResHtml;
		}	
		else
		{
			for(var x = 0; x < webarooResults.length; x++)
			{
				var show = true;
				if(x >= numResultsToDisplay)
					show = false;
				var res = webarooResults[x];
				var tu  =  base+ "?" + queryBase + "=" + encodeURIComponent(res + (IS_isAnd() ? " " + q : ""));
			    inner += "<div id='paa_" + x + "' style='border-top-style:solid;border-top-width:thin;border-top-color:#ffffff;\
			                text-indent:-11px; padding-left:" + pad + ";display:" + (show ? "fixed":"none") + "'>\u2022\u00A0<a id='aa_" + 
			                x +  "' href=" + tu + " style='text-align:justify;'>" + res + "</a></div>";
				if(x == numResultsToDisplay)
				{
					inner += "<div id='showMoreWebarooRes' style='border-top-style:solid;border-top-width:thin;border-top-color:#ffffff;\
			                text-indent:-11px; display:fixed;text-align:right;'><a \
			                		href='javascript:void(null)' style='color:#7777CC'>More </a></div>";
				}			  
			}
		}
		cld.innerHTML = inner;
		var wElem = document.getElementById("webarooTag");
		var styleH = isGoogle ? "style='text-decoration:none;'" : "style='text-decoration:none;color:#0000DE; visted:#663399;'";
        wElem.innerHTML = "<a " + styleH + " href=" + globalUrl + "index?searchQuery=" + encodeURIComponent(q) + 
												"&view=c>" + rsearches + "</a>" + ender;	
		                    
        if(needUpdate(latestVersion))
        {
            wElem.innerHTML += "<br><a style='color:#0000DE; text-decoration:underline;' href=" + globalUrl + "download target='_blank'" + ">Click to update extension</a>"
        }
        
        if(webarooMessage != "")
        {
        	wElem.innerHTML += "<br><div id='webarooMesage'>" + webarooMessage + "</div>"
        }
        
        //click here for more event
		var elem = document.getElementById("showMoreWebarooRes");
		if(elem != null)
		{
			elem.addEventListener("click",
			        function(e)
			        {
			        	var be = document.getElementById("showMoreWebarooRes");
			        	be.style.display = 'none';
						for(var x = numResultsToDisplay; x < 1000; x++)
						{
							var el = document.getElementById("paa_" + x);
							if(el == null)
								break;
							el.style.display = '';
						}
			        }, true);	                    
		}
		for(var x = 0; x < webarooResults.length; x++)
		{
		    var elem = document.getElementById("paa_" + x);
    		elem.addEventListener("click",
                    function(e)
		            {
		                var val = this.id.split("_")[1];
		                var res = webarooResults[val];
			            var tu  =  base+ "?" + queryBase + "=" + encodeURIComponent(res + (IS_isAnd() ? " " + q : ""));
		                GM_setValue('oldQ', q); 
		                document.location = tu;
		            }, 
            true);
        }
		
		var elempop = document.getElementById("pop");
		elempop.addEventListener("mouseover", function(e){
		  inPopup ++;
		}, true);
		elempop.addEventListener("mouseout", function(e){
		  if(prevVal == -1 || toRemovePop != 0)
		  {
		    inPopup --;
		    return;
		  }
		  setTimeout(function(){
		    inPopup--;
		    if(toRemovePop == 0 && inPopup == 0 && prevVal != -1)
		    {
		        var popup = document.getElementById('pop'); 
		        popup.style.visibility = 'hidden';
		        var par = document.getElementById('paa_' + prevVal); 
		        par.style.backgroundColor = "#FFFFFF";
		        par.style.borderTopColor = '#ffffff';
		        prevVal = -1;
		    }
		  }, 200);
		}, true);
		
		for(var x = 0; x < webarooResults.length; x++)
		{
    		var elem = document.getElementById("paa_" + x);
    		elem.addEventListener("mouseover",
                    function(e)
		            {
		                toRemovePop ++;
		                var val = this.id.split("_")[1];
		                
		                if(val == prevVal)
		                {
		                  return;
		                }
		                if(prevVal != -1)
		                {
		                  var popup = document.getElementById('pop'); 
        		          popup.style.visibility = 'hidden';
        		          var par = document.getElementById('paa_' + prevVal);
		                  par.style.backgroundColor = "#FFFFFF";
			              par.style.borderTopColor = '#ffffff';
		                  
		                  prevVal = -1;
		                }
		                if(webarooExcerpts[val] != "")
		                {
		                    var popup = document.getElementById('pop'); 
        		            popup.innerHTML= "<div style='background-color:" + popColor + ";text-align:justify;border-top-style:solid;border-top-color:" + borderColor + ";border-top-width:thin;padding-right:5px;padding-left:15px;text-indent:-10px;'><font size='-1'> " 
        		           + "<b><u>" + webarooResults[val] + "</u>:</b>\u00A0"
			               + webarooExcerpts[val] +
			               "\u00A0\u00A0 <div style='text-align:right;'><a href=" + globalUrl + "r?url=" 
			               + webarooUrls[val]+ ">Source</a></div>" + "</font></div>";
			                popup.style.display='block';
			                popup.style.position='fixed';
			                var obj = this;
                            var curleft = 0;
                            if(obj.offsetParent)
								while(1) 
								{
								  curleft += obj.offsetLeft;
								  if(!obj.offsetParent)
									break;
								  obj = obj.offsetParent;
								}
                            else if(obj.x)
                                curleft += obj.x;
                            curleft -= window.pageXOffset;
                          
                            var curtop = 0;
                            obj = this;
                            if(obj.offsetParent)
								while(1)
								{
								  curtop += obj.offsetTop;
								  if(!obj.offsetParent)
									break;
								  obj = obj.offsetParent;
								}
                            else if(obj.y)
                                curtop += obj.y;
                            curtop -= window.pageYOffset;
			                popup.style.backgroundColor = "#FFFFFF";
			                popup.style.paddingTop = "5px";
			                popup.style.paddingBottom = "5px";
			                popup.style.paddingLeft = "5px";
			                popup.style.top = (curtop - 5) +"px";
			                popup.style.left = (curleft - 400 - 5) + "px";
			                popup.style.maxWidth = '405px';
			                popup.style.minWidth = '405px';
			                popup.style.visibility = 'visible';
			                popup.style.textAlign = 'justify';    			            
                        }
                        var par = document.getElementById('paa_' + val); 
                        par.style.backgroundColor = popColor;
                        par.style.borderTopColor = borderColor;

			            prevVal = val;
		            }, true);
		            
		            
		            elem.addEventListener("mouseout",
                    function(e)
		            {
		                var val = this.id.split("_")[1];
		                if(prevVal != val || inPopup == 1)
		                {
		                    toRemovePop --;
		                    return;
		                }
		                    
		                setTimeout(function(){
		                  toRemovePop --;
		                  if(prevVal == val  && toRemovePop == 0 && inPopup == 0)
		                  {
		                    var popup = document.getElementById('pop'); 
        		            popup.style.visibility = 'hidden';
        		            var par = document.getElementById('paa_' + val); 
		                    par.style.backgroundColor = "#FFFFFF";
			                par.style.borderTopColor = '#ffffff';
			                
			                prevVal = -1;
			              }
                        }, 200);
		            }, true);		            
        }
	}

    //uses isGoogle
	var makeTagCloud = function()
    {
	    var cloud = document.createElement('div');
	    cloud.setAttribute('id', 'cloud');
	    if(!isGoogle)
	        cloud.setAttribute('style', 'float:right;width:236px');
	    cloud.innerHTML = tagCloudHtml;
	    return cloud;
    }

    //fixed with proper variables
	function showWebaroo(respDetails)
	{
	    var parser = new DOMParser();
	    var xmlDoc = parser.parseFromString(respDetails.responseText, 'application/xml');
	    
	    latestVersion = xmlDoc.getElementsByTagName("version")[0].firstChild.nodeValue;
	    webarooMessage = xmlDoc.getElementsByTagName("message")[0].firstChild.nodeValue;
	    var results = xmlDoc.getElementsByTagName("d");
		var excerpts = xmlDoc.getElementsByTagName("e");
		var urls = xmlDoc.getElementsByTagName("s");
		webarooResults = new Array(); 
		webarooExcerpts = new Array();
		webarooUrls = new Array();
		var nctr = 0;
		for (var ctr = 0 ; ctr < results.length; ctr++ ) 
		{
				webarooResults[nctr] = results[ctr].firstChild.nodeValue;
				webarooExcerpts[nctr] = excerpts[ctr].firstChild.nodeValue;
				webarooUrls[nctr] = urls[ctr].firstChild.nodeValue;
				nctr++;
		}
		showResults(nctr);
	}
	
    //Thanks GooglePedia extension for firefox
	var Images =
	{
	  throbber: 'data:image/gif;base64,R0lGODlhEAAQAPMAAP%2F%2F%2F2Zm%2F4uL%2FtfX%2FpWV%2Fq6u%2FuPj%2Fra2%2FsfH%2Fuvr%2FszM%2FtjY%2FvHx%2Ftvb%2FgAAAAAAACH%2BFU1hZGUgYnkgQWpheExvYWQuaW5mbwAh%2BQQBAAAAACH5BAAKAAAAIf8LTkVUU0NBUEUyLjADAQAAACwAAAAAEAAQAAAEPBDISau9dggxMBVBIHgTKJKSxpFGURgoUBBEEc913L6xlCCIRAxxOCCGRQRjsWBgfsGFQrGISamxZdMSAQAh%2BQQACgABACwAAAAAEAAQAAAEPhDIOYQYM2sRgtCTURQG54FSQRBFdaGAysKZSNJAgiAJLiGHA8IHAAqJOh5RwlgsGMSFQrGITqu%2B5nPJ7UYAACH5BAAKAAIALAAAAAAQABAAAAQ%2BEMhpSjEz60JI0VOCIAnnDYIwZMhxINUlBIHAukg215lIZiiVhLFYMECghUKxQGqUTGeGaJRar9isdst1RgAAIfkEAAoAAwAsAAAAABAAEAAABD4QyJkQSjNrdA7SE7MsDOcZRWFki6Is1VUQRMG6SzbXmUhmKBVoCBgIBANiRhAICJQTphMqMSKp2Kx2y91GAAAh%2BQQACgAEACwAAAAAEAAQAAAEPRDIydZiM%2Bul1NIgwHkJgiQhUF3IcSBp1r7xVJ51ZhSFkQMFAqHwCw5%2Fu15tIBAMfoJAQACVUnNM528biwAAIfkEAAoABQAsAAAAABAAEAAABDwQyEmrvdiytViei6IsnxSOJbB1qZQgSJIix4HM9V2%2B8WcUBUOqQCAUMAOBYEA0YgSBgOAXfEYFqeTSEgEAIfkEAAoABgAsAAAAABAAEAAABDwQyEmrvTjrzbufzLIw3KIoS3mmWzhKgyAMVIIgCSUEgUAhhwNCxxMYCgUDUEiJzQoEQsGGw0ClnGPSEgEAIfkEAAoABwAsAAAAABAAEAAABDsQyEmrvTjrzXsdgjBwQhAIpIluoOgZRWFQzLIwVEEQBbUoikVuV0ggEIlfkAKTIQ4HRO2GeUY5RqQlAgA7AAAAAAAAAAAA'
	}

    //Thanks Google Tag Cloud Maker grease monkey script (fixed ... fuction specific to google )
    var getSponsorSite = function()
    {
	    var ts = document.body.getElementsByTagName('table');
	    for(var i = 0; i < ts.length; i++)
	    {
	        if(ts[i].getAttribute('width') == '25%' && ts[i].getAttribute('align') == 'right')
	        {
		        return ts[i];
	        }	
	    }
	    return null;
    }

    // search engine specific
	function webarooSearch(q)
	{
		//show throbber
		var c = makeTagCloud();
        //create dummy pop up
    	var pop = document.createElement('div');
        pop.setAttribute('id', 'pop');
        pop.setAttribute('style', 'display:none');
	    document.body.insertBefore(pop, null);
        //do google specific stuff
        if(isGoogle)
        {
  		    //get Sponsor bar
		    var sponsor = getSponsorSite();
		    //if there is sponsor menu	
		    if(sponsor)
		    {
		    	//sponsor.parentNode.insertBefore(c, sponsor);
/*		    	var addSpace = 	"<table cellspacing=0 cellpadding=0\
				    			 style='position:relative;float:right;width:100%'\
				    			 bgcolor=#ffffff border=0 class=ra><tr height=7>\
							     <td><img width=1 height=1 alt=\"\"></td>\
								 </tr></table>";
				c.innerHTML += addSpace;    	
				c.style.position = 'relative';
				c.style.cssFloat = 'right';    	
				c.style.width = '25%';
		    	var x = sponsor.nextSibling;
		    	sponsor.parentNode.removeChild(sponsor);
			    sponsor.setAttribute('align', null);
		    	sponsor.setAttribute('width', '100%');			
				sponsor.style.position = 'relative';
				sponsor.style.cssFloat = 'right';
			    c.insertBefore(sponsor, null);
				x.parentNode.insertBefore(c, x);
				var tagT = document.getElementById("tagTable");
				tagT.style.width = '100%';
*/
				sponsor.innerHTML = tagCloudHtml + sponsor.innerHTML;
    	    }
		    else
		    {
		    	c.innerHTML = "<table id='tagTable' cellspacing=0 cellpadding=0 style='position:relative;float:right;width:25%' bgcolor=#ffffff border=0 class=ra>" +
		    					tagCloudHtml + "</table>";
		        var tpa = document.getElementById("tpa1");
		        if(tpa != null)
		        {
		            tpa.parentNode.insertBefore(c, tpa);
		        }
		        else	
		        {
			        var t = getElementsByClassName(document.body, "table", "t bt");
			        t[0].parentNode.insertBefore(c, t[0].nextSibling);
                }
		    }
        }
        else
		{
			  	var cont = document.getElementById("yschcont");
			  	if(cont == null)
			  	{
			  		cont = document.getElementById("cont");
			  		cont.setAttribute("style", "float:left");	
			  		var pg = document.getElementById("pg");
			  		pg.setAttribute("style", "clear:left");
			  		cont.parentNode.insertBefore(c, cont.nextSibling);  		
			  	}
			  	else
			  	{
            		cont.parentNode.insertBefore(c, cont.nextSibling);
            	}
		}
		var cld = document.getElementById("cTags");
		cld.innerHTML = throbberHtml;
		var url = globalUrl + "srxml?searchQuery=" + encodeURIComponent(q);
		var x = GM_getValue('oldQ');
		if(x && x != '12787236362182')
		{
		    url += '&oldQ=' + x;
		}
		GM_xmlhttpRequest
		({
				method:'GET',
				url:url,
				onload:showWebaroo,
				onerror: function() {},
				onreadystatechange:function(){}
		});
	}
    if(location.host.match(/google/g))
    {
        isGoogle = true; //variable
        queryBase = "q"; //variable
        borderColor = '#3366CC'; //variable
        popColor = '#E5ECF9'; //variable
        initInner = ""; //variable
        ender = " by <a style='text-decoration:none' href=http://www.webaroo.com/>Webaroo</a>"; //variable
        rsearches = "Search Radar ";
        //header = "Search Radar by <a style='text-decoration:none;' ";  //variable
        throbberHtml = '<img id="throbber" src="'+Images.throbber+'" /> Loading ...'; //variable
        pad = '10px'; //variable
        noResHtml = "No results found."; //variable
        tagCloudHtml = //variable
	        //"<table id='tagTable' cellspacing=0 cellpadding=0 style='position:relative;float:right;width:25%' bgcolor=#ffffff border=0 class=ra>" +
	        (document.getElementById('tpa1') == null ?
	        "<tr>\
		        <td colspan=4><font size=-1>&nbsp;</font></td>\
	        </tr>" : "") +
	        "<tr>\
		        <td rowspan=5 >&nbsp;&nbsp;</td>\
			    <td width=1 bgcolor=#c9d7f1 rowspan=" + ((document.getElementById('tpa1') != null) ? "3" : "5") + "><img width=1 height=1 alt=\"\"></td>\
		        <td rowspan=5 >&nbsp;&nbsp;</td>\
		        <td height=25 align=center><h2  id='webarooTag' class=\"sl f\">Search Radar by <a style='text-decoration:none' \
	        																		href=http://www.webaroo.com>Webaroo</a></h2></td>\
	        </tr>\
            <tr height=7>\
		        <td><img width=1 height=1 alt=\"\"></td>\
	        </tr>\
	        <tr>\
		        <td>\
			        <font size=-1>\
					        <div id='cTags'></div>\
			        </font>\
		        </td>\
	        </tr>" + 
	        (document.getElementById('tpa1') != null ?
	        "<tr>\
		        <td colspan=4><font size=-1>&nbsp;</font></td>\
	        </tr>" : "");
//        </table>";
    }
    else if(location.host.match(/yahoo/g))
    {
        isGoogle = false;  //variable
        queryBase = "p"; //variable
        borderColor = '#B6CDE1'; //variable
        popColor = '#E4F1F8'; //variable
        initInner = "<br>"; //variable
        rsearches = "SEARCH RADAR ";
        ender = " by <a style='text-decoration:none; color:#0000DE; visted:#663399' href=http://www.webaroo.com/>Webaroo</a>"; //variable
        //header = "SEARCH RADAR by <a style='text-decoration:none; color:#0000DE; visted:#663399'";  //variable
        throbberHtml = '<br>\u00A0\u00A0<img id="throbber" src="'+Images.throbber+'" /> Loading ...'; //variable
        pad = '15px'; //variable
        noResHtml = "<br>\u00A0\u00A0 No results found."; //variable
        tagCloudHtml = //variable
         "<h2 style='padding:0pt; margin:0pt;color:#909090;font-family:verdana;\
         font-size:78%;font-size-adjust:none;font-style:normal;font-variant:normal;\
         font-weight:bold;line-height:normal;text-align:center;border-left:1px solid #B6CDE1' id='webarooTag'>SEARCH RADAR by \
		<a style='text-decoration:none;color:#0000DE; visted:#663399' href=http://www.webaroo.com>Webaroo</a></h2>\
         <div id='cTags' style='border-left:1px solid " + borderColor + ";'></div>\
    	 <div style='height:2em'></div>"; 
    }
	var q = getSearchQuery().join(' ');
	q = q.replace(/\&/g, " and ");
    webarooSearch(q);
    var anl = document.createElement('iframe');
   	var x = GM_getValue('oldQ');
    anl.setAttribute('src', globalUrl+"a?searchQuery=" +q + "&client=firefox&search=" + (isGoogle?"google":"yahoo") + ((x && x != '12787236362182') ? "&oldQ="+x:""));
	anl.setAttribute('style', 'height:1px; width:1px; visibility:hidden');
	GM_setValue('oldQ', '12787236362182');
	document.body.insertBefore(anl, null);
    }
    catch(err)
    {
		var cld = document.getElementById("cTags");
		if(cld != null)
			cld.innerHTML = "";
    }
})();
